//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "u_about.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DrawCombos"
#pragma link "DrawTool"
#pragma resource "*.dfm"
TF_main *F_main;
//---------------------------------------------------------------------------
__fastcall TF_main::TF_main(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TF_main::FormShow(TObject *Sender)
{
   Image_lines->Height=ImageRegions->Height;
   Image_lines->Width=ImageRegions->Width;
   Image_lines->Left=ImageRegions->Left;
   Image_lines->Top=ImageRegions->Top;
   Image_symbols->Height=ImageRegions->Height;
   Image_symbols->Width=ImageRegions->Width;
   Image_symbols->Left=ImageRegions->Left;
   Image_symbols->Top=ImageRegions->Top;
   Image_Text->Height=ImageRegions->Height;
   Image_Text->Width=ImageRegions->Width;
   Image_Text->Left=ImageRegions->Left;
   Image_Text->Top=ImageRegions->Top;
   RB_MapInfo->Checked=(DSPS1->PatternStyle == psMapInfo);
   RB_Custom->Checked=(DSPS1->PatternStyle == psCustom);
   DSPS1Change(NULL);
   DSLS2Change(NULL);
   CBSZ1->ItemIndex=4;
   CBSZ2->ItemIndex=5;
   DSSM1Change(NULL);
   DSFTChange(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TF_main::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::FlatControlsClick(TObject *Sender)
{
  TComponent *Temp;
  FlatControls->Checked = ! FlatControls->Checked;
  for (int i=0; i < ComponentCount; ++i){
       Temp = this->Components[i];
       if (dynamic_cast<TDrawStyleComboBox *>(Temp) != NULL)
          (dynamic_cast<TDrawStyleComboBox *>(Temp))->Flat = FlatControls->Checked;
  }
}
//---------------------------------------------------------------------------

void __fastcall TF_main::MouseHitTestClick(TObject *Sender)
{
  TComponent *Temp;
  MouseHitTest->Checked = ! MouseHitTest->Checked;
  for (int i=0; i < ComponentCount; ++i){
       Temp = this->Components[i];
       if (dynamic_cast<TDrawStyleComboBox *>(Temp) != NULL)
          (dynamic_cast<TDrawStyleComboBox *>(Temp))->MouseHitTest = MouseHitTest->Checked;
  }        
}
//---------------------------------------------------------------------------

void __fastcall TF_main::About1Click(TObject *Sender)
{
  AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TF_main::RB_MapInfoClick(TObject *Sender)
{
  if (RB_MapInfo->Checked)
     DSPS1->PatternStyle=psMapInfo;
  else
     DSPS1->PatternStyle=psCustom;
}
//---------------------------------------------------------------------------

void __fastcall TF_main::DSPS1Change(TObject *Sender)
{
   /*
  Use with DrawTool (after conversion from Delphi):

  DrawPolygon(const Types::TPoint * P, const int P_Size, int PCount);
  DrawPolyPolygon(const Types::TPoint * P, const int P_Size, const int * S, const int S_Size, int SCount);

  */

   TPoint  PArray[21];
   Integer SArray[3];

   ImageRegions->Canvas->Brush->Color=DSRBG->Value;
   ImageRegions->Canvas->FillRect(ImageRegions->ClientRect);
   // section 1
   PArray[0]=Point(50,70);
   PArray[1]=Point(200,30);
   PArray[2]=Point(300,50);
   PArray[3]=Point(350,100);
   PArray[4]=Point(300,200);
   PArray[5]=Point(200,250);
   PArray[6]=Point(50,200);
   PArray[7]=Point(50,70);
   // section 2
   PArray[8]=Point(50,250);
   PArray[9]=Point(180,300);
   PArray[10]=Point(180,330);
   PArray[11]=Point(50,330);
   PArray[12]=Point(50,250);
   // section 3
   PArray[13]=Point(220,300);
   PArray[14]=Point(350,235);
   PArray[15]=Point(350,330);
   PArray[16]=Point(220,330);
   PArray[17]=Point(220,300);

   SArray[0]=8;
   SArray[1]=5;
   SArray[2]=5;

   // set DrawTool Region options
   DrawTool->Canvas=ImageRegions->Canvas;
   DrawTool->opRegion->Refresh();
   DrawTool->opRegion->Fill->Pattern=DSPS1->Value;
   DrawTool->opRegion->Fill->Foreground=DSDC1->Value;
   DrawTool->opRegion->Fill->Background=DSDC2->Value;
   DrawTool->opRegion->Fill->UseBackground=CB_UBG->Checked;
   DrawTool->opRegion->Border->Style=DSLS1->Value;
   DrawTool->opRegion->Border->Width=DSLW1->Value;
   DrawTool->opRegion->Border->Color=DSDC3->Value;
   DrawTool->opRegion->Border->BlackColor=DSDBC1->Value;
   DrawTool->opRegion->Border->UseBlackColor=CB_UBCP->Checked;
   // draw regions
   switch (RG_RType->ItemIndex){
   case 0: DrawTool->DrawRectangle(Point(50,30), Point(350,330)); break;
   case 1: DrawTool->DrawRoundRect(Point(50,30), Point(350,330), 50, 50); break;
   case 2: DrawTool->DrawEllipse(Point(50,30), Point(350,330));  break;
   case 3: DrawTool->DrawPolygon(PArray, 7, 8);  break;
   case 4: DrawTool->DrawPolyPolygon(PArray, 17, SArray, 2,3);
   }
   PST->Caption=IntToStr(DSPS1->Value);
   CB_UBG->Enabled=(DSPS1->Value > 2);
   LSTP->Caption=IntToStr(DSLS1->Value);
   CB_UBCP->Enabled=((DSLS1->Value >= 65 && DSLS1->Value <= 67) ||
                     (DSLS1->Value >= 70 && DSLS1->Value <= 72) ||
                     (DSLS1->Value >= 74 && DSLS1->Value <= 77));
}
//---------------------------------------------------------------------------


void __fastcall TF_main::DSLS2Change(TObject *Sender)
{
   /*
  Use with DrawTool (after conversion from Delphi):

  DrawPolyLine(const Types::TPoint * P, const int P_Size, int PCount);
  DrawPolyPolyLine(const Types::TPoint * P, const int P_Size, const int * S, const int S_Size, int SCount);
  DrawPolyBezier(const Types::TPoint * P, const int P_Size,  int PCount);

  */

   TPoint  PArray[21];
   Integer SArray[3];

   Image_lines->Canvas->Brush->Color=DSLBG->Value;
   Image_lines->Canvas->FillRect(Image_lines->ClientRect);
   // section 1
   PArray[0]=Point(50, 50);
   PArray[1]=Point(351, 50);
   PArray[2]=Point(351, 200);
   PArray[3]=Point(50, 200);
   PArray[4]=Point(50, 100);
   PArray[5]=Point(200, 150);
   PArray[6]=Point(200, 250);
   PArray[7]=Point(50, 300);
   // section 2
   PArray[8]=Point(50, 300);
   PArray[9]=Point(200, 300);
   PArray[10]=Point(350, 250);
   PArray[11]=Point(350, 300);

   SArray[0]=8;
   SArray[1]=4;

   // set DrawTool Line options
   DrawTool->opLine->Refresh();
   DrawTool->Canvas=Image_lines->Canvas;

   DrawTool->opLine->Style=DSLS2->Value;
   DrawTool->opLine->Color=DSDC4->Value;
   DrawTool->opLine->Width=DSLW2->Value;
   DrawTool->opLine->BlackColor=DSDBC4->Value;
   DrawTool->opLine->UseBlackColor=CB_UBC->Checked;

   // draw lines
   switch (RG_LType->ItemIndex){
   case 0: DrawTool->DrawLine(Point(50,170),Point(351,170)); break;
   case 1: DrawTool->DrawPolyLine(PArray,7,8); break;
   case 2: DrawTool->DrawPolyPolyLine(PArray,11, SArray,1, 2); break;
   case 3: DrawTool->DrawArc(Point(50,100),Point(300,330),Point(300,300),Point(50,100)); break;
   case 4:  // line 1
            PArray[0]=Point(49,101);
            PArray[1]=Point(77,159);
            PArray[2]=Point(132,90);
            PArray[3]=Point(186,138);
            // line 2
            PArray[4]=Point(240,187);
            PArray[5]=Point(271,123);
            PArray[6]=Point(300,160);
            // line 3
            PArray[7]=Point(320,210);
            PArray[8]=Point(271,230);
            PArray[9]=Point(200,230);

            DrawTool->DrawPolyBezier(PArray,9,10);

   }
   LST->Caption=IntToStr(DSLS2->Value);
   CB_UBC->Enabled=((DSLS2->Value >= 65 && DSLS2->Value <= 67) ||
                    (DSLS2->Value >= 70 && DSLS2->Value <= 72) ||
                    (DSLS2->Value >= 74 && DSLS2->Value <= 77));
}
//---------------------------------------------------------------------------

void __fastcall TF_main::DSSM1Change(TObject *Sender)
{
  DSSM1->FontName = DSFC->FontName;
  TShiftState Shift;
  Shift << ssLeft;
  Image_symbolsMouseDown(Sender, mbLeft, Shift,
  Ceil(Image_symbols->Width / 2) ,Ceil(Image_symbols->Height / 2));
}
//---------------------------------------------------------------------------

void __fastcall TF_main::Image_symbolsMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  Image_symbols->Canvas->Brush->Color=DSSBG->Value;
  Image_symbols->Canvas->FillRect(Image_symbols->ClientRect);

  // set DrawTool Symbol options
  DrawTool->Canvas=Image_symbols->Canvas;
  DrawTool->opSymbol->Refresh();
  DrawTool->opSymbol->FontName=DSSM1->FontName;
  DrawTool->opSymbol->Shape=DSSM1->Value;
  DrawTool->opSymbol->Size=StrToInt(CBSZ1->Text);
  DrawTool->opSymbol->Color=DSDC5->Value;
  DrawTool->opSymbol->Angle=TBar->Position;
  switch (RGR1->ItemIndex) {
  case 0: DrawTool->opSymbol->Background=None;   break;
  case 1: DrawTool->opSymbol->Background=Halo;   break;
  case 2: DrawTool->opSymbol->Background=Border; break;
  }
  DrawTool->opSymbol->Effects.Clear();
  if (CB_Shadow1->Checked) DrawTool->opSymbol->Effects << seShadow;
  if (CB_Bold1->Checked) DrawTool->opSymbol->Effects << seBold;
  // draw symbols
  DrawTool->DrawSymbol(X ,Y);
}
//---------------------------------------------------------------------------

void __fastcall TF_main::DSFTChange(TObject *Sender)
{
  Image_Text->Canvas->Brush->Color=DSTBG->Value;
  Image_Text->Canvas->FillRect(Image_Text->ClientRect);
   // set DrawTool Text options
  DrawTool->Canvas=Image_Text->Canvas;
  DrawTool->opText->Refresh();
  DrawTool->opText->FontName=DSFT->FontName;
  DrawTool->opText->Size=StrToInt(CBSZ2->Text);
  DrawTool->opText->Color=DSDC6->Value;
  DrawTool->opText->Angle=TBar1->Position;
  switch (RGR2->ItemIndex) {
  case  0: DrawTool->opText->Background=None;   break;
  case  1: DrawTool->opText->Background=Halo;  break;
  case  2: DrawTool->opText->Background=Border;
  }
  DrawTool->opText->Effects.Clear();
  if (CB_Shadow2->Checked) DrawTool->opText->Effects << teShadow;
  if (CB_Bold2->Checked) DrawTool->opText->Effects << teBold;
  // draw text
  DrawTool->DrawRotateText("DrawStyles!",195,195);
}
//---------------------------------------------------------------------------


