{==============================================================================
 ======================  DrawStyles library v 2.0  ============================
 ==============================================================================
 =========== Igor Ilyinsky 2007 www.sinn.ru/~mapnn (mapnn@sinn.ru) ============
 ==============================================================================

  Library support 1-77 style of lines and 1-71 (9-11 reserved) style of pattern brush.
  Also supports custom patterns and symbols.
}


unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ImgList, Menus, Mask,
  DrawTool, DrawCombos;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TabSheet2: TTabSheet;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Image_lines: TImage;
    DSPS1: TDSPatternStyleComboBox;
    DSDC1: TDSDrawColorComboBox;
    DSDC2: TDSDrawColorComboBox;
    DSLS1: TDSLineStyleComboBox;
    DSDC3: TDSDrawColorComboBox;
    DSLW1: TDSLineWidthComboBox;
    DSDC4: TDSDrawColorComboBox;
    DSLW2: TDSLineWidthComboBox;
    DSLS2: TDSLineStyleComboBox;
    RG_LType: TRadioGroup;
    RG_RType: TRadioGroup;
    TabSheet3: TTabSheet;
    Image_Text: TImage;
    RG_TEXT: TRadioGroup;
    TabSheet4: TTabSheet;
    Image_symbols: TImage;
    Label10: TLabel;
    DSSM1: TDSSymbolComboBox;
    Label11: TLabel;
    DSDC5: TDSDrawColorComboBox;
    CBSZ1: TComboBox;
    Label14: TLabel;
    DSSBG: TDSDrawColorComboBox;
    RG_SYMBOL: TRadioGroup;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    FlatControls: TMenuItem;
    Label15: TLabel;
    DrawTool: TDSDrawTool;
    Label13: TLabel;
    Label16: TLabel;
    RGR1: TRadioGroup;
    GroupBox3: TGroupBox;
    CB_Shadow1: TCheckBox;
    CB_Bold1: TCheckBox;
    DSFC: TDSFontComboBox;
    MouseHitTest: TMenuItem;
    About1: TMenuItem;
    ImageList1: TImageList;
    RB_MapInfo: TRadioButton;
    RB_Custom: TRadioButton;
    Label12: TLabel;
    CB_UBG: TCheckBox;
    Label17: TLabel;
    DSRBG: TDSDrawColorComboBox;
    Label18: TLabel;
    DSLBG: TDSDrawColorComboBox;
    TBar: TTrackBar;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    DSFT: TDSFontComboBox;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    DSDC6: TDSDrawColorComboBox;
    RGR2: TRadioGroup;
    GroupBox4: TGroupBox;
    CB_Shadow2: TCheckBox;
    CB_Bold2: TCheckBox;
    TBar1: TTrackBar;
    CBSZ2: TComboBox;
    Label26: TLabel;
    Label27: TLabel;
    DSTBG: TDSDrawColorComboBox;
    ImageRegions: TImage;
    Label28: TLabel;
    DSDBC4: TDSDrawColorComboBox;
    CB_UBC: TCheckBox;
    LST: TLabel;
    PST: TLabel;
    Label29: TLabel;
    DSDBC1: TDSDrawColorComboBox;
    CB_UBCP: TCheckBox;
    LSTP: TLabel;
    procedure FormShow(Sender: TObject);
    procedure DSLS2Change(Sender: TObject);
    procedure DSPS1Change(Sender: TObject);
    procedure DSSM1Change(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FlatControlsClick(Sender: TObject);
    procedure CBAN1KeyPress(Sender: TObject; var Key: Char);
    procedure Image_symbolsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DSFCChange(Sender: TObject);
    procedure MouseHitTestClick(Sender: TObject);
    procedure RB_MapInfoClick(Sender: TObject);
    procedure DSFTChange(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses u_about;

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
   Image_lines.Height:=ImageRegions.Height;
   Image_lines.Width:=ImageRegions.Width;
   Image_lines.left:=ImageRegions.left;
   Image_lines.top:=ImageRegions.top;
   Image_symbols.Height:=ImageRegions.Height;
   Image_symbols.Width:=ImageRegions.Width;
   Image_symbols.left:=ImageRegions.left;
   Image_symbols.top:=ImageRegions.top;
   Image_text.Height:=ImageRegions.Height;
   Image_text.Width:=ImageRegions.Width;
   Image_text.left:=ImageRegions.left;
   Image_text.top:=ImageRegions.top;
   RB_MapInfo.Checked:=(DSPS1.PatternStyle = psMapInfo);
   RB_Custom.Checked:=(DSPS1.PatternStyle = psCustom);
   DSPS1Change(nil);
   DSLS2Change(nil);
   CBSZ1.ItemIndex:=4;
   CBSZ2.ItemIndex:=5;
   DSSM1Change(nil);
   DSFTChange(nil);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.FlatControlsClick(Sender: TObject);
var i: integer;
begin
  FlatControls.Checked:= not FlatControls.Checked;
  for i:=0 to ComponentCount - 1 do
  if Components[i] is TDrawStyleComboBox then
     (Components[i] as TDrawStyleComboBox).Flat:=FlatControls.Checked;
end;

procedure TForm1.MouseHitTestClick(Sender: TObject);
var i: integer;
begin
  MouseHitTest.Checked:= not MouseHitTest.Checked;
  for i:=0 to ComponentCount - 1 do
  if Components[i] is TDrawStyleComboBox then
     (Components[i] as TDrawStyleComboBox).MouseHitTest:=MouseHitTest.Checked;
end;

procedure TForm1.CBAN1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9']) then Key:=#0;
end;

procedure TForm1.RB_MapInfoClick(Sender: TObject);
begin
  if RB_MapInfo.Checked then
     DSPS1.PatternStyle:=psMapInfo
  else
     DSPS1.PatternStyle:=psCustom;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;


//////////////////////////////// regions ///////////////////////////////////////

procedure TForm1.DSPS1Change(Sender: TObject);
var PArray: array [0..20] of TPoint;
    SArray: array [0..2] of Integer;
begin
   ImageRegions.Canvas.Brush.Color:=DSRBG.Value;
   ImageRegions.Canvas.FillRect(ImageRegions.ClientRect);
   // section 1
   PArray[0]:=Point(50,70);
   PArray[1]:=Point(200,30);
   PArray[2]:=Point(300,50);
   PArray[3]:=Point(350,100);
   PArray[4]:=Point(300,200);
   PArray[5]:=Point(200,250);
   PArray[6]:=Point(50,200);
   PArray[7]:=Point(50,70);
   // section 2
   PArray[8]:=Point(50,250);
   PArray[9]:=Point(180,300);
   PArray[10]:=Point(180,330);
   PArray[11]:=Point(50,330);
   PArray[12]:=Point(50,250);
   // section 3
   PArray[13]:=Point(220,300);
   PArray[14]:=Point(350,235);
   PArray[15]:=Point(350,330);
   PArray[16]:=Point(220,330);
   PArray[17]:=Point(220,300);

   SArray[0]:=8;
   SArray[1]:=5;
   SArray[2]:=5;

   // set DrawTool Region options
   DrawTool.Canvas:=ImageRegions.Canvas;
   DrawTool.opRegion.Refresh;
   DrawTool.opRegion.Fill.Pattern:=DSPS1.Value;
   DrawTool.opRegion.Fill.Foreground:=DSDC1.Value;
   DrawTool.opRegion.Fill.Background:=DSDC2.Value;
   DrawTool.opRegion.Fill.UseBackground:=CB_UBG.Checked;
   DrawTool.opRegion.Border.Style:=DSLS1.Value;
   DrawTool.opRegion.Border.Width:=DSLW1.Value;
   DrawTool.opRegion.Border.Color:=DSDC3.Value;
   DrawTool.opRegion.Border.BlackColor:=DSDBC1.Value;
   DrawTool.opRegion.Border.UseBlackColor:=CB_UBCP.Checked;
   // draw regions
   with DrawTool do
   case RG_RType.ItemIndex of
   0:    DrawRectangle(Point(50,30), Point(350,330));
   1:    DrawRoundRect(Point(50,30), Point(350,330), 50, 50);
   2:    DrawEllipse(Point(50,30), Point(350,330));
   3:    DrawPolygon(PArray, 8);
   4:    DrawPolyPolygon(PArray, SArray, 3);
   end;
   PST.Caption:=IntToStr(DSPS1.Value);
   CB_UBG.Enabled:=DSPS1.Value > 2;
   LSTP.Caption:=IntToStr(DSLS1.Value);
   CB_UBCP.Enabled:=DSLS1.Value in [65..67,70..72,74..77];
end;
                                                  
//////////////////////////////// lines /////////////////////////////////////////

procedure TForm1.DSLS2Change(Sender: TObject);
var PArray: array [0..20] of TPoint;
    SArray: array [0..2] of Integer;
begin
   Image_lines.Canvas.Brush.Color:=DSLBG.Value;
   Image_lines.Canvas.FillRect(Image_lines.ClientRect);
   // section 1
   PArray[0]:=Point(50, 50);
   PArray[1]:=Point(351, 50);
   PArray[2]:=Point(351, 200);
   PArray[3]:=Point(50, 200);
   PArray[4]:=Point(50, 100);
   PArray[5]:=Point(200, 150);
   PArray[6]:=Point(200, 250);
   PArray[7]:=Point(50, 300);
   // section 2
   PArray[8]:=Point(50, 300);
   PArray[9]:=Point(200, 300);
   PArray[10]:=Point(350, 250);
   PArray[11]:=Point(350, 300);

   SArray[0]:=8;
   SArray[1]:=4;

   // set DrawTool Line options
   DrawTool.Canvas:=Image_lines.Canvas;
   DrawTool.opLine.Refresh;
   DrawTool.opLine.Style:=DSLS2.Value;
   DrawTool.opLine.Color:=DSDC4.Value;
   DrawTool.opLine.Width:=DSLW2.Value;
   DrawTool.opLine.BlackColor:=DSDBC4.Value;
   DrawTool.opLine.UseBlackColor:=CB_UBC.Checked;

   // draw lines
   with DrawTool do
   case RG_LType.ItemIndex of
   0: DrawLine(Point(50,170),Point(351,170));
   1: DrawPolyLine(PArray, 8);
   2: DrawPolyPolyLine(PArray, SArray, 2);
   3: DrawArc(Point(50,100),Point(300,330),Point(300,300),Point(50,100));
   4:  begin
        // line 1
        PArray[0]:=Point(49,101);
        PArray[1]:=Point(77,159);
        PArray[2]:=Point(132,90);
        PArray[3]:=Point(186,138);
        // line 2
        PArray[4]:=Point(240,187);
        PArray[5]:=Point(271,123);
        PArray[6]:=Point(300,160);
        // line 3
        PArray[7]:=Point(320,210);
        PArray[8]:=Point(271,230);
        PArray[9]:=Point(200,230);

        DrawPolyBezier(PArray, 10);
       end;
   end;
   LST.Caption:=IntToStr(DSLS2.Value);
   CB_UBC.Enabled:=DSLS2.Value in [65..67,70..72,74..77];
end;

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////// symbols ///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

procedure TForm1.DSFCChange(Sender: TObject);
begin
  DSSM1.FontName:=DSFC.FontName;
  DSSM1Change(Sender);
end;

procedure TForm1.DSSM1Change(Sender: TObject);
begin
  DSSM1.FontName:=DSFC.FontName;
  Image_symbolsMouseDown(Sender, mbLeft, [ssLeft],
  Image_symbols.Width div 2 ,Image_symbols.Height div 2);
end;

procedure TForm1.Image_symbolsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Image_symbols.Canvas.Brush.Color:=DSSBG.Value;
  Image_symbols.Canvas.FillRect(Image_symbols.ClientRect);

  // set DrawTool Symbol options
  DrawTool.Canvas:=Image_symbols.Canvas;
  DrawTool.opSymbol.FontName:=DSSM1.FontName;    
  DrawTool.opSymbol.Shape:=DSSM1.Value;
  DrawTool.opSymbol.Size:=StrToInt(CBSZ1.Text);
  DrawTool.opSymbol.Color:=DSDC5.Value;
  DrawTool.opSymbol.Angle:=TBAR.Position;
  case RGR1.ItemIndex of
    0: DrawTool.opSymbol.Background:=None;
    1: DrawTool.opSymbol.Background:=Halo;
    2: DrawTool.opSymbol.Background:=Border;
  end;
  DrawTool.opSymbol.Effects:=[];
  if CB_Shadow1.Checked then DrawTool.opSymbol.Effects:=DrawTool.opSymbol.Effects+[seShadow];
  if CB_Bold1.Checked then DrawTool.opSymbol.Effects:=DrawTool.opSymbol.Effects+[seBold];
  // draw symbols
  DrawTool.DrawSymbol(X ,Y);
end;

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////// text /////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

procedure TForm1.DSFTChange(Sender: TObject);
begin
  Image_text.Canvas.Brush.Color:=DSTBG.Value;
  Image_text.Canvas.FillRect(Image_text.ClientRect);
   // set DrawTool Text options
  DrawTool.Canvas:=Image_text.Canvas;
  DrawTool.opText.Refresh;
  DrawTool.opText.FontName:=DSFT.FontName;
  DrawTool.opText.Size:=StrToInt(CBSZ2.Text);
  DrawTool.opText.Color:=DSDC6.Value;
  DrawTool.opText.Angle:=TBAR1.Position;
  case RGR2.ItemIndex of
    0: DrawTool.opText.Background:=None;
    1: DrawTool.opText.Background:=Halo;
    2: DrawTool.opText.Background:=Border;
  end;
  DrawTool.opText.Effects:=[];
  if CB_Shadow2.Checked then DrawTool.opText.Effects:=DrawTool.opText.Effects+[teShadow];
  if CB_Bold2.Checked then DrawTool.opText.Effects:=DrawTool.opText.Effects+[teBold];
  // draw text
  DrawTool.DrawRotateText('DrawStyles!',195,195);
end;

end.
