// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Drawtool.pas' rev: 20.00

#ifndef DrawtoolHPP
#define DrawtoolHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Geometry.hpp>	// Pascal unit
#include <Linetool.hpp>	// Pascal unit
#include <Extctrls.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Drawtool
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TRegionFigure { rfRectangle, rfRoundRect, rfEllipse, rfPolygon, rfPolyPolygon };
#pragma option pop

#pragma option push -b-
enum TPolyFillMode { pfAlternate, pfWinding };
#pragma option pop

#pragma option push -b-
enum TSymbolBackground { None, Halo, Border };
#pragma option pop

#pragma option push -b-
enum TSymbolEffect { seBold, seShadow };
#pragma option pop

typedef Set<TSymbolEffect, seBold, seShadow>  TSymbolEffects;

#pragma option push -b-
enum TTextEffect { teBold, teUnderLine, teShadow, teItalic };
#pragma option pop

typedef Set<TTextEffect, teBold, teItalic>  TTextEffects;

class DELPHICLASS TPatternList;
class PASCALIMPLEMENTATION TPatternList : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FList;
	
public:
	__fastcall TPatternList(void);
	__fastcall virtual ~TPatternList(void);
	int __fastcall Count(void);
	Graphics::TBitmap* __fastcall Bitmap(int index);
};


class DELPHICLASS TLineOptions;
class PASCALIMPLEMENTATION TLineOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TComponent* FOwner;
	int FStyle;
	Graphics::TColor FColor;
	Graphics::TColor FBlackColor;
	int FWidth;
	bool FUseBlackColor;
	
public:
	__fastcall TLineOptions(Classes::TComponent* Owner);
	__property Classes::TComponent* Owner = {read=FOwner};
	void __fastcall Refresh(void);
	
__published:
	__property int Style = {read=FStyle, write=FStyle, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property Graphics::TColor BlackColor = {read=FBlackColor, write=FBlackColor, nodefault};
	__property int Width = {read=FWidth, write=FWidth, nodefault};
	__property bool UseBlackColor = {read=FUseBlackColor, write=FUseBlackColor, nodefault};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TLineOptions(void) { }
	
};


class DELPHICLASS TFillOptions;
class PASCALIMPLEMENTATION TFillOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TComponent* FOwner;
	Controls::TImageList* FImages;
	int FPattern;
	Graphics::TColor FForeground;
	Graphics::TColor FBackground;
	bool FUseBackground;
	
protected:
	void __fastcall SetImages(const Controls::TImageList* Value);
	
public:
	__fastcall TFillOptions(Classes::TComponent* Owner);
	__property Classes::TComponent* Owner = {read=FOwner};
	void __fastcall Refresh(void);
	
__published:
	__property int Pattern = {read=FPattern, write=FPattern, nodefault};
	__property Controls::TImageList* CustomPatterns = {read=FImages, write=SetImages};
	__property Graphics::TColor Foreground = {read=FForeground, write=FForeground, nodefault};
	__property Graphics::TColor Background = {read=FBackground, write=FBackground, nodefault};
	__property bool UseBackground = {read=FUseBackground, write=FUseBackground, nodefault};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TFillOptions(void) { }
	
};


class DELPHICLASS TRegionOptions;
class PASCALIMPLEMENTATION TRegionOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TComponent* FOwner;
	TLineOptions* FBorder;
	TFillOptions* FFill;
	int FPFMode;
	
protected:
	TPolyFillMode __fastcall GetPFMode(void);
	void __fastcall SetPfMode(const TPolyFillMode Value);
	
public:
	__fastcall TRegionOptions(Classes::TComponent* Owner);
	__fastcall virtual ~TRegionOptions(void);
	__property Classes::TComponent* Owner = {read=FOwner};
	void __fastcall Refresh(void);
	
__published:
	__property TLineOptions* Border = {read=FBorder, write=FBorder};
	__property TFillOptions* Fill = {read=FFill, write=FFill};
	__property TPolyFillMode PolyFillMode = {read=GetPFMode, write=SetPfMode, default=1};
};


class DELPHICLASS TSymbolOptions;
class PASCALIMPLEMENTATION TSymbolOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TComponent* FOwner;
	Graphics::TFontName FFontName;
	int FShape;
	int FSize;
	Graphics::TColor FColor;
	int FAngle;
	TSymbolBackground FBackground;
	TSymbolEffects FEffects;
	
public:
	__fastcall TSymbolOptions(Classes::TComponent* Owner);
	__property Classes::TComponent* Owner = {read=FOwner};
	void __fastcall Refresh(void);
	
__published:
	__property Graphics::TFontName FontName = {read=FFontName, write=FFontName};
	__property int Shape = {read=FShape, write=FShape, nodefault};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property int Angle = {read=FAngle, write=FAngle, nodefault};
	__property TSymbolBackground Background = {read=FBackground, write=FBackground, default=0};
	__property TSymbolEffects Effects = {read=FEffects, write=FEffects, default=0};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSymbolOptions(void) { }
	
};


class DELPHICLASS TTextOptions;
class PASCALIMPLEMENTATION TTextOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Classes::TComponent* FOwner;
	Graphics::TFontName FFontName;
	int FSize;
	Graphics::TColor FColor;
	int FAngle;
	TSymbolBackground FBackground;
	TTextEffects FEffects;
	
public:
	__fastcall TTextOptions(Classes::TComponent* Owner);
	__property Classes::TComponent* Owner = {read=FOwner};
	void __fastcall Refresh(void);
	
__published:
	__property Graphics::TFontName FontName = {read=FFontName, write=FFontName};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property int Angle = {read=FAngle, write=FAngle, nodefault};
	__property TSymbolBackground Background = {read=FBackground, write=FBackground, default=0};
	__property TTextEffects Effects = {read=FEffects, write=FEffects, default=0};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TTextOptions(void) { }
	
};


class DELPHICLASS TDSDrawTool;
class PASCALIMPLEMENTATION TDSDrawTool : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TCanvas* FCanvas;
	TLineOptions* FLine;
	TRegionOptions* FRegion;
	TSymbolOptions* FSymbol;
	TTextOptions* FText;
	StaticArray<Types::TPoint, 10001> TmpVertex;
	StaticArray<System::Byte, 10001> TmpTypes;
	Extctrls::TTimer* TT;
	
protected:
	void __fastcall TestCanvas(void);
	void __fastcall DrawRegion(TRegionFigure Figure, Types::TPoint *P, const int P_Size, int *S, const int S_Size, int Count);
	void __fastcall TestLine(const Types::TPoint &P1, const Types::TPoint &P2);
	void __fastcall TestSymbol(int X, int Y);
	
public:
	__property Graphics::TCanvas* Canvas = {read=FCanvas, write=FCanvas};
	__fastcall virtual TDSDrawTool(Classes::TComponent* AOwner);
	__fastcall virtual ~TDSDrawTool(void);
	void __fastcall DrawLine(const Types::TPoint &P1, const Types::TPoint &P2)/* overload */;
	void __fastcall DrawLine(int X1, int Y1, int X2, int Y2)/* overload */;
	void __fastcall DrawPolyLine(Types::TPoint *P, const int P_Size, int PCount);
	void __fastcall DrawPolyPolyLine(Types::TPoint *P, const int P_Size, int *S, const int S_Size, int SCount);
	void __fastcall DrawArc(const Types::TPoint &P1, const Types::TPoint &P2, const Types::TPoint &P3, const Types::TPoint &P4)/* overload */;
	void __fastcall DrawArc(int X1, int Y1, int X2, int Y2, int X3, int Y3, int X4, int Y4)/* overload */;
	void __fastcall DrawPolyBezier(Types::TPoint *P, const int P_Size, int PCount);
	void __fastcall DrawRectangle(const Types::TPoint &P1, const Types::TPoint &P2)/* overload */;
	void __fastcall DrawRectangle(int X1, int Y1, int X2, int Y2)/* overload */;
	void __fastcall DrawRoundRect(const Types::TPoint &P1, const Types::TPoint &P2, int W, int H)/* overload */;
	void __fastcall DrawRoundRect(int X1, int Y1, int X2, int Y2, int W, int H)/* overload */;
	void __fastcall DrawEllipse(const Types::TPoint &P1, const Types::TPoint &P2)/* overload */;
	void __fastcall DrawEllipse(int X1, int Y1, int X2, int Y2)/* overload */;
	void __fastcall DrawPolygon(Types::TPoint *P, const int P_Size, int PCount);
	void __fastcall DrawPolyPolygon(Types::TPoint *P, const int P_Size, int *S, const int S_Size, int SCount);
	void __fastcall DrawSymbol(int X, int Y)/* overload */;
	void __fastcall DrawSymbol(const Types::TPoint &P)/* overload */;
	void __fastcall DrawRotateText(System::UnicodeString sText, int X, int Y);
	
__published:
	__property TLineOptions* opLine = {read=FLine, write=FLine};
	__property TRegionOptions* opRegion = {read=FRegion, write=FRegion};
	__property TSymbolOptions* opSymbol = {read=FSymbol, write=FSymbol};
	__property TTextOptions* opText = {read=FText, write=FText};
};


//-- var, const, procedure ---------------------------------------------------
static const Word MaxPathPoint = 0x2710;
static const ShortInt MaxLineIndex = 0x4c;
extern PACKAGE StaticArray<Graphics::TColor, 272> BaseColor;
extern PACKAGE TPatternList* PatternList;
extern PACKAGE TDSDrawTool* CommonDraw;
extern PACKAGE int OLD_BKMODE;
extern PACKAGE Graphics::TColor OLD_FONT_COLOR;
extern PACKAGE Graphics::TColor OLD_TEXT_COLOR;

}	/* namespace Drawtool */
using namespace Drawtool;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DrawtoolHPP
