// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Geometry.pas' rev: 20.00

#ifndef GeometryHPP
#define GeometryHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Geometry
{
//-- type declarations -------------------------------------------------------
struct TMPoint
{
	
public:
	System::Extended x;
	System::Extended y;
};


typedef TMPoint TMVector;

struct TMPoint3
{
	
public:
	System::Extended x;
	System::Extended y;
	System::Extended z;
};


struct TMSpherePoint
{
	
public:
	System::Extended s;
	System::Extended d;
};


struct TMSegment
{
	
public:
	TMPoint p1;
	TMPoint p2;
};


struct TMLine
{
	
public:
	System::Extended a;
	System::Extended b;
	System::Extended c;
};


//-- var, const, procedure ---------------------------------------------------
static const Extended EPS = 1.000000E-08;
static const Word MAX_POLY_SIZE = 0x2710;
extern PACKAGE System::Extended __fastcall SProd(const TMPoint &v1, const TMPoint &v2);
extern PACKAGE System::Extended __fastcall VProd(const TMPoint &v1, const TMPoint &v2);
extern PACKAGE int __fastcall Orientation(const TMPoint &v1, const TMPoint &v2);
extern PACKAGE TMPoint __fastcall MPoint(const System::Extended x, const System::Extended y);
extern PACKAGE bool __fastcall PointsEqual(const TMPoint &p1, const TMPoint &p2)/* overload */;
extern PACKAGE bool __fastcall PointsEqual(const TMSpherePoint &p1, const TMSpherePoint &p2)/* overload */;
extern PACKAGE TMPoint __fastcall SubVector(const TMPoint &p, const TMPoint &v);
extern PACKAGE TMPoint __fastcall AddVector(const TMPoint &p, const TMPoint &v);
extern PACKAGE TMPoint __fastcall Vector(const TMPoint &sPoint, const TMPoint &ePoint);
extern PACKAGE System::Extended __fastcall VectorLen(const TMPoint &v);
extern PACKAGE System::Extended __fastcall Dist(const TMPoint &p1, const TMPoint &p2)/* overload */;
extern PACKAGE System::Extended __fastcall Dist(const TMPoint3 &p1, const TMPoint3 &p2)/* overload */;
extern PACKAGE Types::TPoint __fastcall RotatePoint(const Types::TPoint &p, const Types::TPoint &c, const System::Extended angle)/* overload */;
extern PACKAGE TMPoint __fastcall RotatePoint(const TMPoint &p, const TMPoint &c, const System::Extended angle)/* overload */;
extern PACKAGE TMLine __fastcall Line(const TMPoint &p1, const TMPoint &p2)/* overload */;
extern PACKAGE TMLine __fastcall Line(const TMSegment &s)/* overload */;
extern PACKAGE System::Extended __fastcall SLineDist(const TMLine &l, const TMPoint &p);
extern PACKAGE System::Extended __fastcall LineDist(const TMLine &l, const TMPoint &p);
extern PACKAGE TMLine __fastcall NormalizeLine(const TMLine &l);
extern PACKAGE TMPoint __fastcall LineNorm(const TMLine &l);
extern PACKAGE TMPoint __fastcall LineDirect(const TMLine &l);
extern PACKAGE TMLine __fastcall LinePerpend(const TMLine &l, const TMPoint &p);
extern PACKAGE TMLine __fastcall LineParallel(const TMLine &l, const TMPoint &p);
extern PACKAGE int __fastcall LineCross(const TMLine &l1, const TMLine &l2, TMPoint &p);
extern PACKAGE System::Extended __fastcall LineX(const TMLine &l, const System::Extended Y);
extern PACKAGE System::Extended __fastcall LineY(const TMLine &l, const System::Extended X);
extern PACKAGE TMPoint __fastcall Mirror(const TMLine &l, const TMPoint &p);
extern PACKAGE TMPoint __fastcall Project(const TMLine &l, const TMPoint &p);
extern PACKAGE TMSegment __fastcall Segment(const TMPoint &p1, const TMPoint &p2);
extern PACKAGE bool __fastcall PointOnSeg(const TMSegment &s, const TMPoint &p);
extern PACKAGE bool __fastcall SegCross(const TMSegment &s1, const TMSegment &s2);
extern PACKAGE System::Extended __fastcall TriSquare(const TMPoint &p1, const TMPoint &p2, const TMPoint &p3)/* overload */;
extern PACKAGE System::Extended __fastcall TriSquare(const System::Extended a, const System::Extended b, const System::Extended c)/* overload */;
extern PACKAGE System::Extended __fastcall NormAngle(const System::Extended a);
extern PACKAGE System::Extended __fastcall NormAngle2PI(const System::Extended a);
extern PACKAGE System::Extended __fastcall Angle(const TMPoint &v1, const TMPoint &v2)/* overload */;
extern PACKAGE System::Extended __fastcall Angle(const TMPoint &p)/* overload */;
extern PACKAGE TMSpherePoint __fastcall SpherePoint(const System::Extended s, const System::Extended d);
extern PACKAGE TMPoint3 __fastcall SphereToCartesian(const TMSpherePoint &p);
extern PACKAGE System::Extended __fastcall Dist(const TMSpherePoint &p1, const TMSpherePoint &p2)/* overload */;
extern PACKAGE TMSpherePoint __fastcall ShiftNorth(const TMSpherePoint &p, const System::Extended dist);
extern PACKAGE TMSpherePoint __fastcall ShiftEast(const TMSpherePoint &p, const System::Extended dist);

}	/* namespace Geometry */
using namespace Geometry;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// GeometryHPP
