// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Texttool.pas' rev: 20.00

#ifndef TexttoolHPP
#define TexttoolHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Geometry.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Texttool
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSymbolBackground { None, Halo, Border };
#pragma option pop

#pragma option push -b-
enum TSymbolEffect { seBold, seShadow };
#pragma option pop

typedef Set<TSymbolEffect, seBold, seShadow>  TSymbolEffects;

#pragma option push -b-
enum TTextEffect { teBold, teUnderLine, teShadow, teItalic };
#pragma option pop

typedef Set<TTextEffect, teBold, teItalic>  TTextEffects;

class DELPHICLASS TDSSymbol;
class PASCALIMPLEMENTATION TDSSymbol : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TFontName FFontName;
	int FShape;
	int FSize;
	Graphics::TColor FColor;
	int FAngle;
	TSymbolBackground FBackground;
	TSymbolEffects FEffects;
	
public:
	__fastcall virtual TDSSymbol(Classes::TComponent* Aowner);
	void __fastcall Refresh(void);
	void __fastcall DrawSymbol(Graphics::TCanvas* Canvas, int X, int Y)/* overload */;
	void __fastcall DrawSymbol(Graphics::TCanvas* Canvas, const Types::TPoint &P)/* overload */;
	
__published:
	__property Graphics::TFontName FontName = {read=FFontName, write=FFontName};
	__property int Shape = {read=FShape, write=FShape, nodefault};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property int Angle = {read=FAngle, write=FAngle, nodefault};
	__property TSymbolBackground Background = {read=FBackground, write=FBackground, default=0};
	__property TSymbolEffects Effects = {read=FEffects, write=FEffects, default=0};
public:
	/* TComponent.Destroy */ inline __fastcall virtual ~TDSSymbol(void) { }
	
};


class DELPHICLASS TDSText;
class PASCALIMPLEMENTATION TDSText : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TFontName FFontName;
	int FSize;
	Graphics::TColor FColor;
	int FAngle;
	TSymbolBackground FBackground;
	TTextEffects FEffects;
	
public:
	__fastcall virtual TDSText(Classes::TComponent* Aowner);
	void __fastcall Refresh(void);
	void __fastcall DrawText(Graphics::TCanvas* Canvas, System::UnicodeString sText, int X, int Y);
	
__published:
	__property Graphics::TFontName FontName = {read=FFontName, write=FFontName};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property int Angle = {read=FAngle, write=FAngle, nodefault};
	__property TSymbolBackground Background = {read=FBackground, write=FBackground, default=0};
	__property TTextEffects Effects = {read=FEffects, write=FEffects, default=0};
public:
	/* TComponent.Destroy */ inline __fastcall virtual ~TDSText(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Texttool */
using namespace Texttool;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// TexttoolHPP
